Module Module1

    'UPGRADE_WARNING: Structure PROCESSENTRY32 may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Private Declare Function Process32First Lib "kernel32" (ByVal hSnapshot As Integer, ByRef lppe As PROCESSENTRY32) As Integer
    'UPGRADE_WARNING: Structure PROCESSENTRY32 may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Private Declare Function Process32Next Lib "kernel32" (ByVal hSnapshot As Integer, ByRef lppe As PROCESSENTRY32) As Integer
    Private Declare Function CloseHandle Lib "Kernel32.dll" (ByVal Handle As Integer) As Integer
    Private Declare Function OpenProcess Lib "Kernel32.dll" (ByVal dwDesiredAccessas As Integer, ByVal bInheritHandle As Integer, ByVal dwProcId As Integer) As Integer
    Private Declare Function GetModuleFileNameExA Lib "psapi.dll" (ByVal hProcess As Integer, ByVal hModule As Integer, ByVal ModuleName As String, ByVal nSize As Integer) As Integer
    Private Declare Function EnumProcessModules Lib "psapi.dll" (ByVal hProcess As Integer, ByRef lphModule As Integer, ByVal cb As Integer, ByRef cbNeeded As Integer) As Integer
    Private Declare Function CreateToolhelp32Snapshot Lib "kernel32" (ByVal dwFlags As Integer, ByVal th32ProcessID As Integer) As Integer
    'UPGRADE_WARNING: Structure OSVERSIONINFO may require marshalling attributes to be passed as an argument in this Declare statement. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="C429C3A5-5D47-4CD9-8F51-74A1616405DC"'
    Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (ByRef lpVersionInformation As OSVERSIONINFO) As Integer
    Private Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hWnd As Integer, ByRef lpdwProcessId As Integer) As Integer
    Private Structure PROCESSENTRY32
        Dim dwSize As Integer
        Dim cntUsage As Integer
        Dim th32ProcessID As Integer
        Dim th32DefaultHeapID As Integer
        Dim th32ModuleID As Integer
        Dim cntThreads As Integer
        Dim th32ParentProcessID As Integer
        Dim pcPriClassBase As Integer
        Dim dwFlags As Integer
        'UPGRADE_WARNING: Fixed-length string size must fit in the buffer. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="3C1E4426-0B80-443E-B943-0627CD55D48B"'
        <VBFixedString(260), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValArray, SizeConst:=260)> Public szExeFile() As Char
    End Structure

    Private Structure OSVERSIONINFO
        Dim dwOSVersionInfoSize As Integer
        Dim dwMajorVersion As Integer
        Dim dwMinorVersion As Integer
        Dim dwBuildNumber As Integer
        Dim dwPlatformId As Integer
        'UPGRADE_WARNING: Fixed-length string size must fit in the buffer. Click for more: 'ms-help://MS.VSExpressCC.v80/dv_commoner/local/redirect.htm?keyword="3C1E4426-0B80-443E-B943-0627CD55D48B"'
        <VBFixedString(128), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValArray, SizeConst:=128)> Public szCSDVersion() As Char
    End Structure


    Private Const VER_PLATFORM_WIN32_WINDOWS As Short = 1
    Private Const PROCESS_QUERY_INFORMATION As Short = 1024
    Private Const PROCESS_VM_READ As Short = 16
    Private Const TH32CS_SNAPPROCESS As Short = &H2S

    Private Function CheckVersion() As Integer
        Dim tOS As OSVERSIONINFO
        tOS.dwOSVersionInfoSize = Len(tOS)
        Call GetVersionEx(tOS)
        CheckVersion = tOS.dwPlatformId
    End Function

    Public Function GetHwndEXE(ByVal hWnd As Integer) As String
        Dim lProcessID, lThread As Integer
        Dim lProcessHandle As Integer
        Dim sName As String
        Dim lModule As Integer
        Dim bMore As Boolean
        Dim tPROCESS As PROCESSENTRY32 = Nothing
        Dim lSnapShot As Integer

        lThread = GetWindowThreadProcessId(hWnd, lProcessID)

        If CheckVersion() = VER_PLATFORM_WIN32_WINDOWS Then
            'Windows 9x
            'Create a SnapShot of the Currently Running Processes
            lSnapShot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)
            If lSnapShot < 0 Then Exit Function

            tPROCESS.dwSize = Len(tPROCESS)

            'Enumerate those processes until we find a match
            bMore = Process32First(lSnapShot, tPROCESS)
            While bMore And tPROCESS.th32ProcessID <> lProcessID
                bMore = Process32Next(lSnapShot, tPROCESS)
            End While

            'If a match was found, get the EXE Path and Filename
            If tPROCESS.th32ProcessID = lProcessID Then
                sName = Left(tPROCESS.szExeFile, InStr(tPROCESS.szExeFile, Chr(0)) - 1)
                GetHwndEXE = sName
            End If

        Else
            'Win NT
            'Create an Instance of the Process
            lProcessHandle = OpenProcess(PROCESS_QUERY_INFORMATION Or PROCESS_VM_READ, 0, lProcessID)

            'If the Process was successfully created, get the EXE
            If lProcessHandle Then
                'Just get the First Module, all we need is the Handle to get the Filename..
                If EnumProcessModules(lProcessHandle, lModule, 4, 0) Then
                    sName = Space(260)
                    Call GetModuleFileNameExA(lProcessHandle, lModule, sName, Len(sName))
                    GetHwndEXE = sName
                End If
                'Close the Process Handle
                Call CloseHandle(lProcessHandle)
            End If

        End If

    End Function

End Module
